#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DEBUG 0

struct fc {
	long n;
	char s[25];
};

int fccomp(const void *a, const void *b) {
	/* sort descending */
	return( ((struct fc*)b)->n - ((struct fc*)a)->n );
}

void main() {
	struct fc t[1005];
	long n,m,k,tc,i,j;
	char buf[25],suffix[5];

	freopen("words.in","r",stdin);
	freopen("words.out","w",stdout);
	scanf("%ld\n",&n);
	while(n--) {
		tc=0;
		scanf("%ld %ld\n",&m,&k);
		if(((k%100)>=11 && (k%100)<=13) || (k%10)<1 || (k%10)>3 ) {
			strcpy(suffix,"th");
		} else {
			switch(k%10) {
				case 1:
					strcpy(suffix,"st");
					break;
				case 2:
					strcpy(suffix,"nd");
					break;
				case 3:
					strcpy(suffix,"rd");
					break;
			}
		}
		printf("%ld%s most common word(s):\n",k,suffix);
		while(m--) {
			scanf("%s\n",buf);
			for(i=0;i<tc;i++) {
				if(!strcmp(t[i].s,buf)) {
					t[i].n++;
					i=tc+10;
				}
			}
			if(i<tc+10) {
				t[tc].n=0;
				strcpy(t[tc].s,buf);
				tc++;
			}
		}
		qsort(t,tc,sizeof(struct fc),fccomp);
if(DEBUG) for(i=0;i<tc;i++) printf("%s %ld\n",t[i].s,t[i].n);
		if(k<=tc) {
			if(k==1 || t[k-1].n < t[k-2].n) {
				i=k-1;
				while(t[k-1].n == t[i].n && i<tc) {
					printf("%s\n",t[i].s);
					i++;
				}
			}
		}
		printf("\n");
	}
}

	
